=== modified file 'configure.ac'
--- configure.ac	2009-08-20 16:14:47 +0000
+++ configure.ac	2009-09-14 22:19:22 +0000
@@ -451,11 +451,25 @@
   AC_MSG_ERROR("Drizzle requires fcntl.")
 fi
 
-AC_CONFIG_LIBOBJ_DIR([gnulib])
+
+AC_CACHE_CHECK([working fdatasync],[ac_cv_func_fdatasync],[
+  AC_LANG_PUSH(C++)
+  AC_RUN_IFELSE([AC_LANG_PROGRAM([[
+#include <unistd.h>
+    ]],[[
+fdatasync(4);
+    ]])],
+  [ac_cv_func_fdatasync=yes],
+  [ac_cv_func_fdatasync=no])
+  AC_LANG_POP()
+])
+AS_IF([test "x${ac_cv_func_fdatasync}" = "xyes"],
+  [AC_DEFINE([HAVE_FDATASYNC],[1],[If the system has a working fdatasync])])
+
 
 AC_CHECK_FUNCS( \
   cuserid fchmod \
-  fdatasync fpresetsticky fpsetmask fsync \
+  fpresetsticky fpsetmask fsync \
   getpassphrase getpwnam \
   getpwuid getrlimit getrusage index initgroups isnan \
   localtime_r log log2 gethrtime gmtime_r \
@@ -656,7 +670,7 @@
 
 dnl Has to be done late, as the plugin may need to check for existence of
 dnl functions tested above
-PANDORA_PLUGINS
+PANDORA_PLUGINS([drizzled/plugin/config.h])
 
 dnl GCC Precompiled Header Support
 dnl re-enable later

=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2009-09-16 21:55:09 +0000
+++ drizzled/Makefile.am	2009-09-21 18:35:01 +0000
@@ -729,6 +729,7 @@
 		$(PCHHEADERS)
 
 EXTRA_DIST = \
+		plugin/config.h.in \
 		$(BUILT_MAINT_SRC) \
 		symbol_hash.gperf \
 		function_hash.gperf \

=== added file 'drizzled/plugin/config.h.in'
--- drizzled/plugin/config.h.in	1970-01-01 00:00:00 +0000
+++ drizzled/plugin/config.h.in	2009-09-14 18:25:40 +0000
@@ -0,0 +1,27 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_PLUGIN_CONFIG_H
+#define DRIZZLED_PLUGIN_CONFIG_H
+
+/* The list of builtin plugins */
+#define  PANDORA_BUILTIN_LIST @PANDORA_BUILTIN_LIST@
+
+#endif /* DRIZZLED_PLUGIN_CONFIG_H */
+

=== modified file 'drizzled/sql_plugin.cc'
--- drizzled/sql_plugin.cc	2009-08-24 14:57:56 +0000
+++ drizzled/sql_plugin.cc	2009-09-14 18:25:40 +0000
@@ -30,6 +30,7 @@
 #include <drizzled/session.h>
 #include <drizzled/item/null.h>
 #include <drizzled/plugin/registry.h>
+#include "drizzled/plugin/config.h"
 
 #include <string>
 #include <vector>

=== removed file 'm4/dtrace.m4'
--- m4/dtrace.m4	2008-12-02 21:16:50 +0000
+++ m4/dtrace.m4	1970-01-01 00:00:00 +0000
@@ -1,20 +0,0 @@
-dnl ---------------------------------------------------------------------------
-dnl Macro: DTRACE_TEST
-dnl ---------------------------------------------------------------------------
-AC_ARG_ENABLE([dtrace],
-    [AS_HELP_STRING([--enable-dtrace],
-            [Build with support for the DTRACE. @<:@default=off@:>@])],
-    [ENABLE_DTRACE="yes"],
-    [ENABLE_DTRACE="no"])
-
-if test "$ENABLE_DTRACE" = "yes"
-then
-  AC_DEFINE([HAVE_DTRACE], [1], [Enables DTRACE Support])
-  AC_CHECK_PROGS(DTRACE, dtrace)
-  AC_SUBST(DTRACEFLAGS)
-  AC_SUBST(HAVE_DTRACE)
-fi
-AM_CONDITIONAL([BUILD_DTRACE], [ test "$ENABLE_DTRACE" = "yes" ])
-dnl ---------------------------------------------------------------------------
-dnl End Macro: DTRACE_TEST
-dnl ---------------------------------------------------------------------------

=== modified file 'm4/pandora_64bit.m4'
--- m4/pandora_64bit.m4	2009-08-04 17:58:31 +0000
+++ m4/pandora_64bit.m4	2009-09-14 18:03:11 +0000
@@ -23,7 +23,7 @@
   AS_IF([test "$isainfo_b" != "x"],[
 
     isainfo_k=`${ISAINFO} -k` 
-    DTRACEFLAGS="${DTRACEFLAGS} -${isainfo_k}"
+    DTRACEFLAGS="${DTRACEFLAGS} -${isainfo_b}"
 
     AS_IF([test "x$ac_enable_64bit" = "xyes"],[
 

=== modified file 'm4/pandora_canonical.m4'
--- m4/pandora_canonical.m4	2009-08-24 14:58:00 +0000
+++ m4/pandora_canonical.m4	2009-09-16 18:34:16 +0000
@@ -4,7 +4,7 @@
 dnl with or without modifications, as long as this notice is preserved.
 
 dnl Which version of the canonical setup we're using
-AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.51])
+AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.61])
 
 AC_DEFUN([PANDORA_FORCE_DEPEND_TRACKING],[
   dnl Force dependency tracking on for Sun Studio builds
@@ -23,6 +23,7 @@
   m4_define([PCT_REQUIRE_CXX],[no])
   m4_define([PCT_IGNORE_SHARED_PTR],[no])
   m4_define([PCT_FORCE_GCC42],[no])
+  m4_define([PCT_SRC_IN_SRC],[no])
   m4_foreach([pct_arg],[$*],[
     m4_case(pct_arg,
       [use-gnulib], [
@@ -40,6 +41,10 @@
       [force-gcc42], [
         m4_undefine([PCT_FORCE_GCC42])
         m4_define([PCT_FORCE_GCC42],[yes])
+      ],
+      [src-in-src], [
+        m4_undefine([PCT_SRC_IN_SRC])
+        m4_define([PCT_SRC_IN_SRC],[yes])
     ])
   ])
 
@@ -94,7 +99,10 @@
     ])
   ])
   
-  m4_if(PCT_USE_GNULIB, [yes], [gl_INIT])
+  m4_if(PCT_USE_GNULIB, [yes], [
+    gl_INIT
+    AC_CONFIG_LIBOBJ_DIR([gnulib])
+  ])
 
   AC_C_BIGENDIAN
   AC_C_CONST
@@ -137,6 +145,9 @@
     AM_CPPFLAGS="-I\$(top_srcdir)/gnulib -I\$(top_builddir)/gnulib ${AM_CPPFLAGS}"
     ])
   ])
+  AS_IF([test "PCT_SRC_IN_SRC" = "yes"],[
+    AM_CPPFLAGS="-I\$(top_srcdir)/src -I\$(top_builddir)/src ${AM_CPPFLAGS}"
+  ])
 
   PANDORA_USE_PIPE
 

=== modified file 'm4/pandora_enable_dtrace.m4'
--- m4/pandora_enable_dtrace.m4	2009-07-08 07:09:13 +0000
+++ m4/pandora_enable_dtrace.m4	2009-09-16 18:20:25 +0000
@@ -17,6 +17,7 @@
     AC_CHECK_PROGS([DTRACE], [dtrace])
     AS_IF([test "x$ac_cv_prog_DTRACE" = "xdtrace"],[
       AC_DEFINE([HAVE_DTRACE], [1], [Enables DTRACE Support])
+      AC_MSG_CHECKING([if dtrace should instrument object files])
       dnl DTrace on MacOSX does not use -G option
       cat >conftest.d <<_ACEOF
 provider Example {
@@ -24,9 +25,10 @@
 };
 _ACEOF
       $DTRACE -G -o conftest.d.o -s conftest.d 2>/dev/zero
-      AS_IF([test $? -eq 0],[ac_cv_dtrace_needs_objects=yes])
+      AS_IF([test $? -eq 0],[ac_cv_dtrace_needs_objects=yes],
+            [ac_cv_dtrace_needs_objects=no])
       rm -f conftest.d.o conftest.d
-
+      AC_MSG_RESULT($ac_cv_dtrace_needs_objects)
       AC_SUBST(DTRACEFLAGS) dnl TODO: test for -G on OSX
       ac_cv_have_dtrace=yes
     ])])

=== modified file 'm4/pandora_ensure_gcc_version.m4'
--- m4/pandora_ensure_gcc_version.m4	2009-07-08 07:09:13 +0000
+++ m4/pandora_ensure_gcc_version.m4	2009-09-14 18:03:11 +0000
@@ -8,12 +8,15 @@
 AC_DEFUN([PANDORA_MAC_GCC42],
   [AS_IF([test "$GCC" = "yes"],[
     AS_IF([test "$host_vendor" = "apple" -a "x${ac_cv_env_CC_set}" = "x"],[
-      AS_IF([test -f /usr/bin/gcc-4.2],
+      host_os_version=`echo ${host_os} | perl -ple 's/^\D+//g;s,\..*,,'`
+      AS_IF([test "$host_os_version" -lt 10],[
+        AS_IF([test -f /usr/bin/gcc-4.2],
         [
           CPP="/usr/bin/gcc-4.2 -E"
           CC=/usr/bin/gcc-4.2
           CXX=/usr/bin/g++-4.2
         ])
+      ])
     ])
   ])
 ])

=== modified file 'm4/pandora_platform.m4'
--- m4/pandora_platform.m4	2009-07-29 22:03:46 +0000
+++ m4/pandora_platform.m4	2009-09-14 18:03:11 +0000
@@ -63,6 +63,15 @@
   AC_CHECK_DECL([__SUNPRO_C], [SUNCC="yes"], [SUNCC="no"])
   AC_CHECK_DECL([__ICC], [INTELCC="yes"], [INTELCC="no"])
 
-  AS_IF([test "x$INTELCC" = "xyes"], [enable_rpath=no])
+  AS_IF([test "$INTELCC" = "yes"], [enable_rpath=no])
+ 
+  dnl By default, Sun Studio grabs special versions of limits.h and string.h
+  dnl when you use <cstring> and <climits>. By setting this define, we can
+  dnl disable that and cause those to wrap the standard headers instead.
+  dnl http://www.stlport.com/doc/configure.html
+  AS_IF([test "$SUNCC" = "yes"],[
+    AC_DEFINE([_STLP_NO_NEW_C_HEADERS],[1],
+      [Cause Sun Studio to not be quite so strict with standards conflicts])
+  ])
 
 ])

=== modified file 'm4/pandora_plugins.m4'
--- m4/pandora_plugins.m4	2009-08-23 00:12:08 +0000
+++ m4/pandora_plugins.m4	2009-09-14 23:36:15 +0000
@@ -16,8 +16,15 @@
                       value is given for --plugin-load])
 
   pandora_builtin_list=`echo $pandora_builtin_list | sed 's/, *$//'`
-  AC_DEFINE_UNQUOTED([PANDORA_BUILTIN_LIST],[$pandora_builtin_list],
-                     [List of plugins to be built in])
+  AS_IF([test "x$pandora_builtin_list" = "x"], pandora_builtin_list="NULL")
+  AC_SUBST([PANDORA_BUILTIN_LIST],[$pandora_builtin_list])
+  m4_ifval(m4_normalize([$1]),[
+    AC_CONFIG_FILES($*)
+    ],[
+    AC_DEFINE_UNQUOTED([PANDORA_BUILTIN_LIST],[$pandora_builtin_list],
+                       [List of plugins to be built in])
+  ])
+
 
   AC_SUBST(pandora_plugin_test_list)
   AC_SUBST(pandora_plugin_libs)

=== modified file 'm4/pandora_pthread.m4'
--- m4/pandora_pthread.m4	2009-07-26 20:11:34 +0000
+++ m4/pandora_pthread.m4	2009-09-14 18:03:11 +0000
@@ -14,12 +14,56 @@
 dnl  Check for libpthread
 dnl --------------------------------------------------------------------
 
+AC_DEFUN([PANDORA_PTHREAD_YIELD],[
+  AC_REQUIRE([ACX_PTHREAD])
+
+  save_CFLAGS="${CFLAGS}"
+  save_CXXFLAGS="${CXXFLAGS}"
+  CFLAGS="${PTHREAD_CFLAGS} ${CFLAGS}"
+  CXXFLAGS="${PTHREAD_CFLAGS} ${CXXFLAGS}"
+  dnl Some OSes like Mac OS X have that as a replacement for pthread_yield()
+  AC_CHECK_FUNCS(pthread_yield_np)
+  AC_CACHE_CHECK([if pthread_yield takes zero arguments],
+    [pandora_cv_pthread_yield_zero_arg],
+    [AC_LINK_IFELSE([
+      AC_LANG_PROGRAM([[
+#include <pthread.h>
+        ]],[[
+  pthread_yield();
+        ]])],
+      [pandora_cv_pthread_yield_zero_arg=yes],
+      [pandora_cv_pthread_yield_zero_arg=no])])
+  AS_IF([test "$pandora_cv_pthread_yield_zero_arg" = "yes"],[
+    AC_DEFINE([HAVE_PTHREAD_YIELD_ZERO_ARG], [1],
+              [pthread_yield that doesn't take any arguments])
+  ])
+
+  AC_CACHE_CHECK([if pthread_yield takes one argument],
+    [pandora_cv_pthread_yield_one_arg],
+    [AC_LINK_IFELSE([
+      AC_LANG_PROGRAM([[
+#include <pthread.h>
+        ]],[[
+  pthread_yield(0);
+        ]])],
+      [pandora_cv_pthread_yield_one_arg=yes],
+      [pandora_cv_pthread_yield_one_arg=no])])
+  AS_IF([test "$pandora_cv_pthread_yield_one_arg" = "yes"],[
+    AC_DEFINE([HAVE_PTHREAD_YIELD_ONE_ARG], [1],
+              [pthread_yield function with one argument])
+  ])
+
+  CFLAGS="${save_CFLAGS}"
+  CXXFLAGS="${save_CXXFLAGS}"
+])
+
+
 AC_DEFUN([_PANDORA_SEARCH_PTHREAD],[
-  ACX_PTHREAD
+  AC_REQUIRE([ACX_PTHREAD])
   LIBS="${PTHREAD_LIBS} ${LIBS}"
   AM_CFLAGS="${PTHREAD_CFLAGS} ${AM_CFLAGS}"
   AM_CXXFLAGS="${PTHREAD_CFLAGS} ${AM_CXXFLAGS}"
-  CC="$PTHREAD_CC"
+  PANDORA_PTHREAD_YIELD
 ])
 
 

=== modified file 'm4/pandora_vc_build.m4'
--- m4/pandora_vc_build.m4	2009-08-23 00:12:08 +0000
+++ m4/pandora_vc_build.m4	2009-09-14 22:25:25 +0000
@@ -38,3 +38,20 @@
 
 ])
   
+dnl Takes one argument which is the prefix to append
+AC_DEFUN([PANDORA_EXPORT_BZR_INFO],[
+  m4_ifval(m4_normalize([$1]),[
+    m4_define([PEBI_PREFIX],[])
+  ],[
+    m4_define([PEBI_PREFIX],m4_toupper(m4_normalize($1))[_])
+  ])
+
+  AC_DEFINE(PEBI_PREFIX[BZR_REVID], ["BZR_REVID"], [bzr revision ID])
+  AC_DEFINE(PEBI_PREFIX[BZR_BRANCH], ["BZR_BRANCH"], [bzr branch name])
+  AC_DEFINE(PEBI_PREFIX[RELEASE_DATE], ["RELEASE_DATE"], [Release date based on the date of the repo checkout])
+  AC_DEFINE(PEBI_PREFIX[RELEASE_VERSION], ["RELEASE_VERSION"], [$1 version number formatted for display])
+  AC_DEFINE(PEBI_PREFIX[RELEASE_COMMENT], ["RELEASE_COMMENT"], [Set to trunk if the branch is the main $1 branch])
+  AC_DEFINE(PEBI_PREFIX[RELEASE_ID], [RELEASE_ID], [$1 version number formatted for numerical comparison])
+ 
+])
+

=== modified file 'm4/pandora_warnings.m4'
--- m4/pandora_warnings.m4	2009-08-10 20:34:41 +0000
+++ m4/pandora_warnings.m4	2009-09-14 23:36:15 +0000
@@ -204,10 +204,49 @@
       AS_IF([test "$ac_cv_safe_to_use_Wredundant_decls_" = "yes"],
             [CXX_WARNINGS="${CXX_WARNINGS} -Wredundant-decls"],
             [CXX_WARNINGS="${CXX_WARNINGS} -Wno-redundant-decls"])
+
+      AC_CACHE_CHECK([whether it is safe to use -Wattributes from C++],
+        [ac_cv_safe_to_use_Wattributes_],
+        [AC_LANG_PUSH(C++)
+         save_CXXFLAGS="${CXXFLAGS}"
+         CXXFLAGS="${W_FAIL} -pedantic -Wattributes -fvisibility=hidden ${AM_CXXFLAGS}"
+         AC_COMPILE_IFELSE(
+           [AC_LANG_PROGRAM([
+#include <google/protobuf/message.h>
+#include <google/protobuf/descriptor.h>
+
+
+const ::google::protobuf::EnumDescriptor* Table_TableOptions_RowType_descriptor();
+enum Table_TableOptions_RowType {
+  Table_TableOptions_RowType_ROW_TYPE_DEFAULT = 0,
+  Table_TableOptions_RowType_ROW_TYPE_FIXED = 1,
+  Table_TableOptions_RowType_ROW_TYPE_DYNAMIC = 2,
+  Table_TableOptions_RowType_ROW_TYPE_COMPRESSED = 3,
+  Table_TableOptions_RowType_ROW_TYPE_REDUNDANT = 4,
+  Table_TableOptions_RowType_ROW_TYPE_COMPACT = 5,
+  Table_TableOptions_RowType_ROW_TYPE_PAGE = 6
+};
+
+namespace google {
+namespace protobuf {
+template <>
+inline const EnumDescriptor* GetEnumDescriptor<Table_TableOptions_RowType>() {
+  return Table_TableOptions_RowType_descriptor();
+}
+}
+}
+            ])],
+            [ac_cv_safe_to_use_Wattributes_=yes],
+            [ac_cv_safe_to_use_Wattributes_=no])
+          CXXFLAGS="${save_CXXFLAGS}"
+          AC_LANG_POP()])
+      AS_IF([test "$ac_cv_safe_to_use_Wattributes_" = "yes"],
+            [],
+            [CXX_WARNINGS="${CXX_WARNINGS} -Wno-attributes"])
   
       NO_REDUNDANT_DECLS="-Wno-redundant-decls"
       dnl TODO: Figure out a better way to deal with this:
-      PROTOSKIP_WARNINGS="-Wno-effc++ -Wno-shadow -Wno-missing-braces"
+      PROTOSKIP_WARNINGS="-Wno-effc++ -Wno-shadow -Wno-missing-braces -Wno-attributes"
       NO_WERROR="-Wno-error"
       INNOBASE_SKIP_WARNINGS="-Wno-shadow -Wno-cast-align"
       

